<!-- <svg id="graph" width="300" height="200" style="border: 1px solid black;"></svg> -->
<svg id="graph" width="300" height="200" style="background-color: transparent; border: 1px solid black; "></svg>
<textarea id="code" style="width: 600px; height: 200px; resize: none; border: 1px solid red;">
</textarea> <button onclick='eval(document.getElementById("code").value);'> Run </button>

<script>
class Graph {
  constructor(element, negative, max, spacing, grid=true, styling=["stroke:rgb(255,0,0);stroke-width:2","silver","stroke:black;stroke-width:1","stroke:grey;stroke-width:1"]){ 
  	this.element = element;
    this.width = element.width.baseVal.value;
    this.height = element.height.baseVal.value;
    this.max = max;
    this.spacing = spacing;
    this.record = [];
    this.negative = negative;
    this.grid = grid;
    this.styling = styling;
  }
  renderGrid(){
  	var i = 0;
  	var result = "";
  	this.element.style.background = this.styling[1];
  	var current;
  	while (i < (this.width / this.spacing)){
  		result += "<line x1=\""+(i*this.spacing)+"\" y1=\"0\" x2=\""+(i*this.spacing)+"\" y2=\""+(this.max*this.height)+"\" style=\""+this.styling[2]+"\" />";
  		i++;
  	}
  	i = 0;
  	while (i < (this.height / this.max*2)){
  		result += "<line x1=\"0\" y1=\""+(i * this.max/2)+"\" x2=\""+(this.width)+"\" y2=\""+(i * this.max/2)+"\" style=\""+this.styling[3]+"\" />";
  		i++;
  	}
  	return result;
  }
  render(offset=0){
  	var result = "";
  	if (this.grid) result = this.renderGrid();
  	var i = offset;
  	var previous;
  	var current;
  	while (i < this.record.length){
  		if (this.negative) current = this.max/2 - this.record[i];
  		else current = this.max - this.record[i];

  		if (i != offset) 
  			result += "<line x1=\""+((i-1)*this.spacing)+"\" y1=\""+(previous / this.max * this.height)
  					+"\" x2=\""+((i-1)*this.spacing+this.spacing)+"\" y2=\""+(current / this.max * this.height)+"\" style=\""+this.styling[0]+"\" />";
  		previous = current;
  		i++;
  	}
  	this.element.innerHTML = result;
  }
  add(value){
  	if (value instanceof Array) this.record = this.record.concat(value);
  	else this.record.push(value);
  }
  insert(i, value){
  	this.record.splice(i, 0, value);
  }
  remove(i, value){
  	this.record.splice(i, 1);
  }

}
//graph.innerHTML = '<line x1="0" y1="0" x2="200" y2="200" style="stroke:rgb(255,0,0);stroke-width:2" />';

</script>

<script>
document.getElementById("code").value = 
'var graph = new Graph(document.getElementById("graph"), true, 24, 10,grid=true);\n graph.add(2);\n graph.add(5);\n graph.add([2,1,4,6,2,1,4,6,2,1,4,6,2,1,4,6,2,1,4,6,2,1,4,6,2,1,4,6,13,16,12,4]);\n graph.render();\n\n//var graph = new Graph(..., styling=["stroke:rgb(255,0,0);stroke-width:2","silver","stroke:black;stroke-width:1","stroke:grey;stroke-width:1"]);\n\n//var variable = new Graph(element, negative, max, spacing);\n//negative = from -max to max (otherwise: 0 to max)'




</script>